Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
LinearVectorForce Class Reference

Simple directed vector force. More...

`#include "linearVectorForce.h"`

Inheritance diagram for LinearVectorForce:

## Public Member Functions
| LinearVectorForce (const LinearVectorForce &copy)
| Copy Constructor.
| LinearVectorForce (const LVector3 &vec, PN_stdfloat a=1.0f, bool mass=false)
| Vector Constructor.
| LinearVectorForce (PN_stdfloat x=0.0f, PN_stdfloat y=0.0f, PN_stdfloat z=0.0f, PN_stdfloat a=1.0f, bool mass=false)
| Default/Piecewise constructor.
virtual | ~LinearVectorForce ()
| Destructor.
virtual TypeHandle | force_init_type ()
LVector3 | get_local_vector () const
virtual TypeHandle | get_type () const
LinearVectorForce & | operator+= (const LinearVectorForce &other)
| Performs a memberwise addition between two LinearVectorForces.
virtual void | output (std::ostream &out) const
| Write a string representation of this instance to <out>.
void | set_vector (const LVector3 &v)
| encapsulating wrapper
void | set_vector (PN_stdfloat x, PN_stdfloat y, PN_stdfloat z)
| piecewise encapsulating wrapper
virtual void | write (std::ostream &out, int indent=0) const
| Write a string representation of this instance to <out>.
Public Member Functions inherited from LinearForce
| ~LinearForce ()
| Destructor.
PN_stdfloat | get_amplitude () const
bool | get_mass_dependent () const
LVector3 | get_vector (const PhysicsObject *po)
LVector3 | get_vector_masks ()
virtual bool | is_linear () const
void | set_amplitude (const PN_stdfloat a)
void | set_mass_dependent (bool m)
void | set_vector_masks (bool x, bool y, bool z)
Public Member Functions inherited from BaseForce
virtual | ~BaseForce ()
| destructor
bool | get_active () const
ForceNode * | get_force_node () const
NodePath | get_force_node_path () const
void | set_active (bool active)
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from LinearForce
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from BaseForce
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

Simple directed vector force.

Suitable for gravity, non-turbulent wind, etc...

Definition at line 23 of file linearVectorForce.h.

## Constructor & Destructor Documentation

## ◆ LinearVectorForce() [1/3]

LinearVectorForce::LinearVectorForce | ( | const LVector3 & | vec,
|  | PN_stdfloat | a = 1.0f,
|  | bool | mass = false )
| explicit

Vector Constructor.

Definition at line 26 of file linearVectorForce.cxx.

Referenced by LinearVectorForce(), and operator+=().

## ◆ LinearVectorForce() [2/3]

LinearVectorForce::LinearVectorForce | ( | PN_stdfloat | x = 0.0f,
|  | PN_stdfloat | y = 0.0f,
|  | PN_stdfloat | z = 0.0f,
|  | PN_stdfloat | a = 1.0f,
|  | bool | mass = false )
| explicit

Default/Piecewise constructor.

Definition at line 35 of file linearVectorForce.cxx.

## ◆ LinearVectorForce() [3/3]

LinearVectorForce::LinearVectorForce | ( | const LinearVectorForce & | copy | ) |

Copy Constructor.

Definition at line 44 of file linearVectorForce.cxx.

References LinearVectorForce().

## ◆ ~LinearVectorForce()

LinearVectorForce::~LinearVectorForce | ( |  | ) |
| virtual

Destructor.

Definition at line 53 of file linearVectorForce.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle LinearVectorForce::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from LinearForce.

Definition at line 60 of file linearVectorForce.h.

## ◆ get_class_type()

static TypeHandle LinearVectorForce::get_class_type | ( |  | ) |
| inline static

Definition at line 49 of file linearVectorForce.h.

## ◆ get_local_vector()

LVector3 LinearVectorForce::get_local_vector | ( |  | ) | const
| inline

Definition at line 33 of file linearVectorForce.I.

## ◆ get_type()

virtual TypeHandle LinearVectorForce::get_type | ( |  | ) | const
| inline virtual

Reimplemented from LinearForce.

Definition at line 57 of file linearVectorForce.h.

## ◆ init_type()

static void LinearVectorForce::init_type | ( |  | ) |
| inline static

Definition at line 52 of file linearVectorForce.h.

## ◆ operator+=()

LinearVectorForce & LinearVectorForce::operator+= | ( | const LinearVectorForce & | other | ) |
| inline

Performs a memberwise addition between two LinearVectorForces.

Definition at line 41 of file linearVectorForce.I.

References LinearVectorForce().

## ◆ output()

void LinearVectorForce::output | ( | std::ostream & | out | ) | const
| virtual

Write a string representation of this instance to <out>.

Reimplemented from LinearForce.

Definition at line 76 of file linearVectorForce.cxx.

## ◆ set_vector() [1/2]

void LinearVectorForce::set_vector | ( | const LVector3 & | v | ) |
| inline

encapsulating wrapper

Definition at line 17 of file linearVectorForce.I.

## ◆ set_vector() [2/2]

void LinearVectorForce::set_vector | ( | PN_stdfloat | x,
|  | PN_stdfloat | y,
|  | PN_stdfloat | z )
| inline

piecewise encapsulating wrapper

Definition at line 25 of file linearVectorForce.I.

## ◆ write()

void LinearVectorForce::write | ( | std::ostream & | out,
|  | int | indent = 0 ) const
| virtual

Write a string representation of this instance to <out>.

Reimplemented from LinearForce.

Definition at line 86 of file linearVectorForce.cxx.

References indent(), and LinearForce::write().

The documentation for this class was generated from the following files:

- panda/src/physics/linearVectorForce.h
- panda/src/physics/linearVectorForce.cxx
- panda/src/physics/linearVectorForce.I